----------------------------------------------------------------------------------
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
entity ckdiv1 is
    Port ( clk : in  STD_LOGIC;
           out_msb : out  STD_LOGIC_VECTOR (3 downto 0));
end ckdiv1;

rchitecture Behavioral of ckdiv1 is
signal count: std_logic_vector(26 downto 0); 
alias cmsb : std_logic_vector(3 downto 0) is count(26 downto 23);
begin
   process(clk)
	begin
	  if clk'event and clk='1' then
          count <= count +1; 	  
	  end if; 
	end process; 
	out_msb <= cmsb; 

end Behavioral;

